package diploma;

import java.util.*;

public class Analyzer extends Object {
    
    String pattern;
    Vector is = new Vector();
    Vector ns = new Vector();
    Vector fs = new Vector();
    
    //constructor
    public Analyzer(String init_pattern) {
        pattern = init_pattern;
    }


    
//******************************************************************************    
// provede remapovani odstinenych znaku (\+ nema ridici vyznam) zpet na puvodni znak  
    static String ReMap(String znak){
        if(znak.equals("\uFFF0"))      { znak="\\";}
        else if(znak.equals("\uFFF1")) { znak="+";}
        else if(znak.equals("\uFFF2")) { znak="*";}
        else if(znak.equals("\uFFF3")) { znak="(";}
        else if(znak.equals("\uFFF4")) { znak=")";}
        else if(znak.equals("\uFFF5")) { znak="?";}
        else if(znak.equals("?")) { znak="DC";}
        return znak;
    }
    
//******************************************************************************    
// provede namapovani odstinenych znaku (\+ nema ridici vyznam) na jiny bezkolizni rozsah
// UNDER CONSTRUCTION !!!
    String ShieldedChars(){
        String tmp = pattern;
        
        int k = tmp.indexOf("\\\\");   //chci nahradit vsechny vyskyty \\
        while(k != -1){
            StringBuffer sb = new StringBuffer(tmp);
            tmp = sb.replace(k,k+2,"\uFFF0").toString();
            sb = null;
            k = tmp.indexOf("\\\\");
        }
        
        k = tmp.indexOf("\\+");   //chci nahradit vsechny vyskyty \+
        while(k != -1){
            StringBuffer sb = new StringBuffer(tmp);
            tmp = sb.replace(k,k+2,"\uFFF1").toString();
            sb = null;
            k = tmp.indexOf("\\+");
        }
        
        k = tmp.indexOf("\\*");   //chci nahradit vsechny vyskyty \*
        while(k != -1){
            StringBuffer sb = new StringBuffer(tmp);
            tmp = sb.replace(k,k+2,"\uFFF2").toString();
            sb = null;
            k = tmp.indexOf("\\*");
        }
        
        k = tmp.indexOf("\\(");   //chci nahradit vsechny vyskyty \(
        while(k != -1){
            StringBuffer sb = new StringBuffer(tmp);
            tmp = sb.replace(k,k+2,"\uFFF3").toString();
            sb = null;
            k = tmp.indexOf("\\(");
        }
        
        k = tmp.indexOf("\\)");   //chci nahradit vsechny vyskyty \)
        while(k != -1){
            StringBuffer sb = new StringBuffer(tmp);
            tmp = sb.replace(k,k+2,"\uFFF4").toString();
            sb = null;
            k = tmp.indexOf("\\)");
        }
        
        k = tmp.indexOf("\\?");   //chci nahradit vsechny vyskyty \?
        while(k != -1){
            StringBuffer sb = new StringBuffer(tmp);
            tmp = sb.replace(k,k+2,"\uFFF5").toString();
            sb = null;
            k = tmp.indexOf("\\?");
        }
    return tmp;
    }
    
    
//******************************************************************************    
// vraci vstup rozdeleny podle ridiciho znaku + na jednotlive subvzorky
    Vector SplitPattern(String init_pattern){  
        Vector v = new Vector();   //obsahuje jednotlive rozdelene vzorky   
        int index = 0; //index ukazuje do vzorku, odkud vyhledavam vyskyt znaku * 
                       //pri dalsim hledani chci pokracovat az za vyhledanym znakem
        int k;         //urcuje pozici znaku * v retezci (pokud se tam vyskytuje)
        
        StringTokenizer st = new StringTokenizer(init_pattern,"+");
        while(st.hasMoreTokens()){
            StringBuffer sb = new StringBuffer(st.nextToken());
                index=0;        
                while( (k = sb.toString().indexOf('*',index)) != -1){
                    index = k+3; //priste budu zacinat az na nasledujicim znaku *
                    if(sb.charAt(k-1)!=')'){
                        sb.insert(k,')');
                        sb.insert(k-1,'(');
                    }    
                }            
            v.addElement(sb.toString());
        }        
        st = null;          //uvolnim tokenizer        
        return(v);
    }
    

//******************************************************************************
// prijima vektor subvzorku a vraci pole vektoru s ocislovanymi symboly
    Vector Enumerate(Vector v){
        String s;
        Vector x = new Vector(); //vytvorim vektor vektoru - pro kazdy level(vzorek)
        
        for(int i=0; i<v.size(); i++){
            s=(String)v.elementAt(i);
            x.addElement(new Vector());              // i-ty vektor pole
            int k=0;                       // cislovac neridicich znaku
            for(int j=0; j<s.length(); j++){
                // ocisluju jen ty neridici
                if(s.charAt(j)!='(' && s.charAt(j)!=')' && s.charAt(j)!='*'){
                    ((Vector)x.elementAt(i)).addElement(s.substring(j,j+1) + "+" + k + "+" + i + "+0");
                    k++;
                }else{
                    ((Vector)x.elementAt(i)).addElement(s.substring(j,j+1));
                }
            }
        }
        return x;
    }
        
    
//******************************************************************************
    Vector Expand(Vector v){
        Vector t;
        Vector exp = new Vector();
        List start, subs, end;
        for(int i=0; i<v.size(); i++){
            t = (Vector)v.elementAt(i);         // vektor pro jeden konkretni vzorek
            int k = t.indexOf("*");
            if(k != -1){
                int m=k;
                while( !( ((String)t.elementAt(m)).equals("(") ) ) { m--; }
                Vector v1 = new Vector();
                v1.addAll(t.subList(0,m));
                v1.addAll(t.subList(k+1,t.size()));
                v.addElement(v1);
                
                Vector v2 = new Vector();
                v2.addAll(t.subList(0,m));
                v2.addAll(t.subList(m+1,k-1));
                v2.addAll(t.subList(k+1,t.size()));
                v.addElement(v2);
                
                Vector v3 = new Vector();
                v3.addAll(t.subList(0,m));
                v3.addAll(t.subList(m+1,k-1));
                v3.addAll(t.subList(m+1,k-1));
                v3.addAll(t.subList(k+1,t.size()));
                v.addElement(v3);
                
            }else{
                if(!exp.contains(t)){
                        exp.addElement(t);  //plne expandovane polozky bez iterace
                }
            }
        }
        return exp;
    }
    
//******************************************************************************
// prijima vektor subvzorku a vraci seznam retezcu bez iterace 
    /*
    Vector Expanse(Vector v){
    Vector exp = new Vector();
    Vector t = new Vector();
    String s, start, subs, end;
    
    
    for(int i=0; i<v.size(); i++){
        s = (String)v.elementAt(i);
       // while(v.size()>0){
           // s = (String)v.elementAt(0);
                
                int k = s.indexOf('*');  //najdi vyskyt prvniho znaku iterace *
                if(k != -1){
                    int m = k;
                    while(s.charAt(m) != '('){ m--; } //najdi k ni prislusnou levou zavorku
                    start = s.substring(0,m);
                    subs = s.substring(m+1,k-1);   //najdu obsah zavorek, co se iteruje
                    end = s.substring(k+1);
                
                    v.addElement(start + end);
                    v.addElement(start + subs + end );
                    v.addElement(start + subs + subs + end);
                }
                else{
                    if(!exp.contains(s)){
                        exp.addElement(s+"+");  //plne expandovane polozky bez iterace
                    }
                }
                v.removeElementAt(0); //prvni polozku mohu zrusit, bud neobsahuje zadnou iteraci
                                      //nebo jsem jednu expandoval a misto ni vlozil nove 3 polozky
        }
        v = null; //uvolnim vektor
        return exp;
    }
*/
//******************************************************************************    
// vrati vektor initsymbolu, jimiz muze zacinat nejaky vzorek
    String makeInitSet(Vector exp){
        String s="";
        Vector t;
        
        for(int i=0; i<exp.size(); i++){
            t = (Vector)exp.elementAt(i);
            if(!t.isEmpty() && !is.contains((String)t.elementAt(0)) ){                
                is.addElement((String)t.elementAt(0));
                s.concat((String)t.elementAt(0));
            }
        }
        return s;
    }
 
    
//******************************************************************************    
// vrati vektor sousedu
    String makeNeighbourSet(Vector exp){
        String s="";
        Vector t;
        
        for(int i=0; i<exp.size(); i++){
            t = (Vector)exp.elementAt(i);
            for(int j=0; j<t.size()-1; j++){
                if(!ns.contains( (String)t.elementAt(j)+"+"+(String)t.elementAt(j+1) )){
                    ns.addElement((String)t.elementAt(j)+"+"+(String)t.elementAt(j+1));
                    s.concat((String)t.elementAt(j)+"+"+(String)t.elementAt(j+1));
                }
            }
        }
        return s;
    }

//******************************************************************************    
// vrati vektor konecnych symbolu
    String makeFinalSet(Vector exp){
        String s="";
        Vector t;
        
        for(int i=0; i<exp.size(); i++){
            t = (Vector)exp.elementAt(i);
            if(!t.isEmpty() && !fs.contains( (String)t.elementAt(t.size()-1) )){
                fs.addElement((String)t.elementAt(t.size()-1));
                s.concat((String)t.elementAt(t.size()-1));
            }
        }
        return s;
    }
    
    
//******************************************************************************
// urci zda je jedna o jeden (0), vice (1) nebo nekonecne (2) vzorku    
    int getTypeOfPattern(){
        int unions=0;
        int iterations=0;
    
        for(int i=0; i<pattern.length(); i++){
            if (pattern.charAt(i)=='+') { if(!(i>0 && pattern.charAt(i-1)=='\\')) unions++; } //pokud pred tim neni \
            if (pattern.charAt(i)=='*') { if(!(i>0 && pattern.charAt(i-1)=='\\')) iterations++;}
        }
        if(iterations>0) {return 2;}
        else if(unions>0) {return 1;}
        else return 0;
    }

    
//******************************************************************************
// urci zda vzorek obsahuje don't care symboly, care (0), dont care (1) 
    int getCareOfPattern(){
        int dontcare = 0;
    
        for(int i=0; i<pattern.length(); i++){
            if (pattern.charAt(i)=='?') { if(!(i>0 && pattern.charAt(i-1)=='\\')) dontcare++;}
        }
        if(dontcare>0) {return 1;}
        else return 0;
    }
 
    
}