package diploma;
import java.lang.*;

public class Validator extends Object {


    
//******************************************************************************    
// kontroluje vstupni retezec a vraci, zda se jedna o korektni RE nebo vraci chybovy kod   
    int Validate(String input) {
       int N = input.length(); //delka vzorku
       int ok = 0;  //ok bez chyb
       int brackets = 0; 
    
       for(int i=0; i<N; i++){
                //pocitam si pocet levych a pravych zavorek
                if( input.charAt(i)=='(' ) { brackets++; }
                if( input.charAt(i)==')' ) { brackets--; }
                //vzorek musi mit na kazde pozici shodne levych jako pravych zavorek, nebo vice levych
                if(brackets<0){ok=17;}
                if(Character.getNumericValue(input.charAt(i))==0) {ok=18;}
                //System.out.println(Character.getType(input.charAt(i)));
       }
    
       //vzorek musi byt neprazdny
        if(input.equals("")) {ok=1;}
        
        //vzorek nesmi  zacinat ridicimi znaky { +, *, ) } 
        else if( input.charAt(0)=='+' || input.charAt(0)=='*' || input.charAt(0)==')') {ok=2;}
        
        //vzorek nesmi koncit sekvenci "(" ale sekvenci "\(" ano
        else if( N == 1 && (input.charAt(0)=='(' || input.charAt(0)=='\\' )) {ok=15;}
        
        //vzorek musi mit stejny pocet levych jako pravych zavorek
        else if( brackets != 0) {ok=16;}       
        
        //vzorek nesmi koncit sekvenci "\" ale sekvenci "\\" ano
        else if( input.substring(N-1).equals("\\") && !(input.substring(N-2).equals("\\\\")) ) {ok=3;}
        
        //vzorek nesmi koncit sekvenci "(" ale sekvenci "\(" ano
        else if( input.substring(N-1).equals("(") && !(input.substring(N-2).equals("\\(")) ) {ok=4;}
        
        //vzorek nesmi koncit sekvenci ")" ale sekvenci "\)" ano
        else if( input.substring(N-1).equals(")") && !(input.substring(N-2).equals("\\)")) ) {ok=5;}
        
        //vzorek nesmi koncit sekvenci "+" ale sekvenci "\+" ano
        else if( input.substring(N-1).equals("+") && !(input.substring(N-2).equals("\\+")) ) {ok=6;}
       
        else { brackets = 0;
            for(int i=0; i<N-2; i++){
                //pocitam si pocet levych a pravych zavorek
                if( input.charAt(i)=='(' ) { brackets++; }
                if( input.charAt(i)==')' ) { brackets--; }
                
                //vzorek nesmi obsahovat sekvenci "++" ale sekvenci "\++" ano
                if( input.substring(i+1,i+3).equals("++") && !(input.substring(i,i+3).equals("\\++")) ) {ok=7;}
                
                //vzorek nesmi obsahovat sekvenci "**" ale sekvenci "\**" ano
                if( input.substring(i+1,i+3).equals("**") && !(input.substring(i,i+3).equals("\\**")) ) {ok=8;}
                
                //vzorek nesmi obsahovat sekvenci "))" ale sekvenci "\))" ano
                if( input.substring(i+1,i+3).equals("))") && !(input.substring(i,i+3).equals("\\))")) ) {ok=9;}
                
                //vzorek nesmi obsahovat sekvenci "()" ale sekvenci "\()" ano
                if( input.substring(i+1,i+3).equals("()") && !(input.substring(i,i+3).equals("\\()")) ) {ok=10;}
                
                //vzorek nesmi obsahovat sekvenci "(*" ale sekvenci "\(*" ano
                if( input.substring(i+1,i+3).equals("(*") && !(input.substring(i,i+3).equals("\\(*")) ) {ok=11;}//
                
                //vzorek nesmi obsahovat sekvenci "+*" ale sekvenci "\+*" ano
                if( input.substring(i+1,i+3).equals("+*") && !(input.substring(i,i+3).equals("\\+*")) ) {ok=12;}
                
                //vzorek musi po ridicim znaku ")" obsahovat "\)"
                if( input.substring(i+1,i+2).equals(")") && !(input.substring(i,i+2).equals("\\)")) && !(input.substring(i+2,i+3).equals("*")) ) {ok=13;}//
                
                //vzorek nesmi obsahovat ridici znak "+" uvnitr zavorek
                if( input.substring(i+2,i+3).equals("+") && !(input.substring(i+1,i+3).equals("\\+*")) && brackets>0 ) {ok=14;}
            }
        }
                
    return(ok);
    } //end of method Validate()

    
    
//******************************************************************************    
//na zaklade chyboveho kodu vrati chybovou zpravu
    String PrintError(int err){
        String ErrString;
        switch(err){
            case 1:  { ErrString = "Vzorek musi byt neprazdny"; break; }
            case 2:  { ErrString = "Vzorek nesmi  zacinat ridicimi znaky '+', '*', ')'"; break; }
            case 3:  { ErrString = "Vzorek nesmi koncit ridicim znakem '\\'"; break; }
            case 4:  { ErrString = "Vzorek nesmi koncit ridicim znakem '('"; break; }                        
            case 5:  { ErrString = "Vzorek nesmi koncit ridicim znakem ')'"; break; } 
            case 6:  { ErrString = "Vzorek nesmi koncit ridicim znakem '+'"; break; } 
            case 7:  { ErrString = "Vzorek nesmi obsahovat sekvenci ridicich znaku '++'"; break; } 
            case 8:  { ErrString = "Vzorek nesmi obsahovat sekvenci ridicich znaku '**'"; break; } 
            case 9:  { ErrString = "Vzorek nesmi obsahovat sekvenci ridicich znaku '))'"; break; } 
            case 10: { ErrString = "Vzorek nesmi obsahovat sekvenci ridicich znaku '()'"; break; } 
            case 11: { ErrString = "Vzorek nesmi obsahovat sekvenci ridicich znaku '(*'"; break; } 
            case 12: { ErrString = "Vzorek nesmi obsahovat sekvenci ridicich znaku '+*'"; break; } 
            case 13: { ErrString = "Vzorek musi obsahovat za ridicim znakem ')' ridici znak '*'"; break; } 
            case 14: { ErrString = "Vzorek nesmi obsahovat ridici znak '+' uvnitr zavorek"; break; } 
            case 15: { ErrString = "Jednoznakovy vzorek nemuze byt tvoren ridicim znakem '(' nebo '\\'"; break; }
            case 16: { ErrString = "Vzorek musi obsahovat stejny pocet levych jako pravych zavorek"; break; }
            case 17: { ErrString = "Vzorek musi na kazde pozici alespon tolik levych zavorek co pravych"; break; }
            case 18: { ErrString = "Vzorek obsahuje znak neprirazeny v kodovani UNICODE"; break; }
            default: { ErrString = "Jina chyba"; break; }
        }
        return ErrString;
    }
    
    
    
}//end of class Validator
